Package owl.automaton

## Class AutomatonUtil

- java.lang.Object
- - owl.automaton.AutomatonUtil

-     public final class AutomatonUtil
      extends Object

- - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static Automaton<Object,​OmegaAcceptance>` | `cast​(Object automaton)` |
    `static <A extends OmegaAcceptance> Automaton<Object,​A>` | `cast​(Object automaton, Class<A> acceptanceClass)` |
    `static <S,​A extends OmegaAcceptance> Automaton<S,​A>` | `cast​(Object automaton, Class<S> stateClass, Class<A> acceptanceClass)` |
    `static <S,​A extends OmegaAcceptance> Automaton<S,​A>` | `cast​(Automaton<S,​?> automaton, Class<A> acceptanceClass)` |
    `static <S> void` | `forEachNonTransientEdge​(Automaton<S,​?> automaton, BiConsumer<S,​Edge<S>> action)` |
    `static <S> BitSet` | `getAcceptanceSets​(Automaton<S,​?> automaton)` | Collect all acceptance sets occurring on transitions within the given state set.
    `static <S> BitSet` | `getAcceptanceSets​(Automaton<S,​?> automaton, Set<S> states)` | Collect all acceptance sets occurring on transitions within the given state set.
    `static <S> Map<S,​ValuationSet>` | `getIncompleteStates​(Automaton<S,​?> automaton)` | Determines all states which are incomplete, i.e.
    `static <S> Set<S>` | `getNondeterministicStates​(Automaton<S,​?> automaton)` |
    `static <S,​B extends GeneralizedBuchiAcceptance> Optional<Set<S>>` | `ldbaSplit​(Automaton<S,​B> automaton)` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### cast

          public static Automaton<Object,​OmegaAcceptance> cast​(Object automaton)

    - #### cast

          public static <A extends OmegaAcceptance> Automaton<Object,​A> cast​(Object automaton,
                                                                                   Class<A> acceptanceClass)

    - #### cast

          public static <S,​A extends OmegaAcceptance> Automaton<S,​A> cast​(Object automaton,
                                                                                      Class<S> stateClass,
                                                                                      Class<A> acceptanceClass)

    - #### cast

          public static <S,​A extends OmegaAcceptance> Automaton<S,​A> cast​(Automaton<S,​?> automaton,
                                                                                      Class<A> acceptanceClass)

    - #### forEachNonTransientEdge

          public static <S> void forEachNonTransientEdge​(Automaton<S,​?> automaton,
                                                         BiConsumer<S,​Edge<S>> action)

    - #### getIncompleteStates

          public static <S> Map<S,​ValuationSet> getIncompleteStates​(Automaton<S,​?> automaton)

      Determines all states which are incomplete, i.e. there are valuations for which the state has no successor.
      Parameters:
        `automaton` - The automaton.
      Returns:
        The set of incomplete states and the missing valuations.

    - #### getNondeterministicStates

          public static <S> Set<S> getNondeterministicStates​(Automaton<S,​?> automaton)

    - #### getAcceptanceSets

          public static <S> BitSet getAcceptanceSets​(Automaton<S,​?> automaton,
                                                     Set<S> states)

      Collect all acceptance sets occurring on transitions within the given state set.
      Type Parameters:
        `S` - the type of the states
      Parameters:
        `automaton` - the automaton
        `states` - the state set
      Returns:
        a set containing all acceptance indices

    - #### getAcceptanceSets

          public static <S> BitSet getAcceptanceSets​(Automaton<S,​?> automaton)

      Collect all acceptance sets occurring on transitions within the given state set.
      Parameters:
        `automaton` - the automaton
      Returns:
        a set containing all acceptance indices

    - #### ldbaSplit

          public static <S,​B extends GeneralizedBuchiAcceptance> Optional<Set<S>> ldbaSplit​(Automaton<S,​B> automaton)